const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const audit_logs = sequelize.define(
    'audit_logs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

action: {
        type: DataTypes.ENUM,
      
      

        values: [

"CREATE",


"UPDATE",


"DELETE",


"LOGIN",


"LOGOUT",


"LOGIN_FAILED",


"POST",


"VOID",


"APPROVE",


"REJECT"

        ],

      },

module: {
        type: DataTypes.TEXT,
      
      

      },

entityId: {
        type: DataTypes.TEXT,
      
      

      },

entityType: {
        type: DataTypes.TEXT,
      
      

      },

oldValueJson: {
        type: DataTypes.TEXT,
      
      

      },

newValueJson: {
        type: DataTypes.TEXT,
      
      

      },

ipAddress: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

eventAt: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  audit_logs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













































//end loop



    db.audit_logs.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.audit_logs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.audit_logs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return audit_logs;
};


